#!/usr/bin/python
import rospy
import mysql.connector
import datetime
import json
from std_msgs.msg import String
from sensor_msgs.msg import NavSatFix

def callback(data, args):
  mydb = args[0]
  mycursor = args[1]
  id_num = args[2]
  table = args[3]

  rospy.loginfo(rospy.get_caller_id() + "%s", data)

  if data.header.seq % 10 == 0: # only update every 10th message to avoid over crowding the sql
    gps_data = {
      "gps" : [
        {
          "lat" : data.latitude,
          "log" : data.longitude,
          "stamp" : data.header.seq
        },
      ]
    }
    sql_data = {'gpsdata': json.dumps(gps_data),
          'taskid':'search_0',
          'created_at':datetime.datetime.now(),
          'updated_at':datetime.datetime.now(),
          'deviceid' : 'drone_0'}

    sql_update = 'UPDATE ' + table + \
    ' SET {}'.format(', '.join('{}=%s'.format(k) for k in sql_data)) +\
    ' WHERE id = %s'

    mycursor.execute(sql_update, sql_data.values()+[id_num])
    mydb.commit()
    
def listener():

    # In ROS, nodes are uniquely named. If two nodes with the same
    # name are launched, the previous one is kicked off. The
    # anonymous=True flag means that rospy will choose a unique
    # name for our 'listener' node so that multiple listeners can
    # run simultaneously.

    table = 'app3_gpsdata'

    mydb = mysql.connector.connect(
      host="172.29.56.174",
      user="VACSE",
      passwd="VACSE529",
      database="saruser"
    )

    mycursor = mydb.cursor()

    id_num = 4 # id which we want to update

    rospy.init_node('db_uploader', anonymous=True)
    rospy.Subscriber("dji_sdk/gps_position", NavSatFix, callback, (mydb, mycursor, id_num, table))

    # spin() simply keeps python from exiting until this node is stopped
    rospy.spin()

if __name__ == '__main__':
    listener()
